<template>
  <div
    class="item-grid item-small"
    :class="[swiperslide != null ? swiperslide : '']"
  >
    <div class="content-top" :class="{ compared: isCompared }">
      <div class="image-container">
        <nuxt-link
          class="ava"
          :to="'/' + product.shared_url + '?option=' + product.sku"
        >
          <img
            v-if="product.thumbnail != null"
            class="lazyload"
            data-sizes="auto"
            :data-srcset="
              $device.isMobile
                ? resizeImage(baseImageUrl + product.thumbnail, 147, 147)
                : resizeImage(baseImageUrl + product.thumbnail, 155, 155) +
                  ' 200w, ' +
                  resizeImage(baseImageUrl + product.thumbnail, 210, 210) +
                  ' 300w'
            "
            src="placeholder.jpg"
            alt="product image"
          />
          <img v-else src="placeholder.jpg" alt="product image" />
        </nuxt-link>
        <div class="product-label">
          <span
            v-for="trangthai in product.trangthaihang"
            :key="trangthai.id"
            class="label label-new"
            :class="{
              'label-new': trangthai.content === 'Mới về',
              'label-comming': trangthai.notes !== '',
            }"
          >
            {{ trangthai.content }}
          </span>
          <span v-if="product.sale" class="label label-sale">
            -{{ product.sale }}
          </span>
        </div>
      </div>
    </div>
    <div class="content-bottom">
      <div v-if="product.date_ve" class="time-action">
        Còn {{ product.date_ve }} ngày
      </div>
      <nuxt-link
        class="name"
        :to="'/' + product.shared_url + '?option=' + product.sku"
      >
        {{ product.name }}
      </nuxt-link>
      <div v-if="product.sku" class="code">SKU: {{ product.sku }}</div>
      <div class="product-price">
        <div class="price">
          <strong>
            {{ (product.sale_price || product.price) | formatNumber }}
          </strong>
        </div>
        <div v-if="product.sale_price" class="price_old">
          {{ product.price | formatNumber }}
        </div>
      </div>
      <div class="content-more">
        <div v-if="product.option_name" class="desc-global">
          <!-- eslint-disable-next-line vue/no-v-html -->
          <div v-html="product.option_name"></div>
        </div>
        <div v-if="notifiButton === true" class="more_btn">
          <a class="btn-default" href="javascript:;">
            Nhận thông báo khi có hàng
          </a>
        </div>
        <div v-else class="more_btn">
          <a
            class="btn-default color-white add-cart"
            href="javascript:;"
            @click="addToCart(product)"
          >
            Thêm vào giỏ hàng
          </a>
          <a
            class="btn-default white add-compare"
            href="javascript:;"
            @click="addToCompare(product)"
          >
            Thêm vào so sánh
          </a>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
import Helper from '../../assets/config'
import { EventBus } from '~/plugins/bus'

export default {
  name: 'SmallProduct',
  // eslint-disable-next-line vue/require-prop-types
  props: ['product', 'swiperslide', 'notifiButton'],
  computed: {
    baseImageUrl() {
      return Helper.baseImageUrl
    },
    compares() {
      return this.$store.state.compares
    },
    isCompared() {
      return this.compares.some((el) => el.sku === this.product.sku)
    },
  },
  mounted() {},
  methods: {
    resizeImage(url, width, height) {
      return Helper.resizeImage(url, width, height)
    },
    addToCart(product) {
      this.$store.commit('add', product)
    },
    addToCompare(product) {
      EventBus.$emit('open-block-compare', true)
      const found = this.compares.some((el) => el.sku === product.sku)
      if (!found) {
        this.$axios.$get('/option/type/' + product.sku).then((type) => {
          if (this.compares.length === 4) {
            alert('Bạn không thể so sánh lớn hơn 4 sản phẩm !')
            return
          }
          if (type !== 'phu-kien') {
            product.type = type
            this.$store.commit('addcompare', product)
          } else {
            alert('Những sản phẩm phụ kiện không hỗ trợ so sánh!')
          }
        })
      } else {
        alert('Sản phẩm đã được thêm vào danh sách so sánh!')
      }
      setTimeout(function () {
        EventBus.$emit('open-block-compare', false)
      }, 5000)
    },
  },
}
</script>
